"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var express = require("express");
var skip_response_1 = require("./skip.response");
var validate_object_1 = require("./validate-object");
var http_verb_1 = require("./http-verb");
var base_middleware_1 = require("./base.middleware");
var logger_1 = require("./logger");
function retrieveArgumentsNamesFromRoute(path) {
    var args = [];
    var parts = path.split("/");
    for (var _i = 0, parts_1 = parts; _i < parts_1.length; _i++) {
        var part = parts_1[_i];
        if (part.startsWith(":")) {
            var arg = part.substring(1, part.length);
            var endIndex = arg.indexOf("(");
            if (endIndex != -1) {
                arg = arg.substring(0, endIndex);
            }
            args.push(arg);
        }
    }
    return args;
}
function generateStandardCallback(controller, route, app) {
    var _this = this;
    return function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
        var _i, _a, verify, passed, f, argsNames, argsValues, _b, argsNames_1, arg, b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    req.lynx = {
                        route: route
                    };
                    if (!route.verifiers) return [3 /*break*/, 6];
                    _i = 0, _a = route.verifiers;
                    _c.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 6];
                    verify = _a[_i];
                    passed = true;
                    if (!verify.isAsync) return [3 /*break*/, 3];
                    return [4 /*yield*/, verify.fun(req, res)];
                case 2:
                    passed = _c.sent();
                    return [3 /*break*/, 4];
                case 3:
                    if (verify.fun) {
                        passed = verify.fun(req, res);
                    }
                    else {
                        try {
                            passed = verify(req, res);
                        }
                        catch (e) {
                            logger_1.logger.error(e);
                        }
                    }
                    _c.label = 4;
                case 4:
                    if (!passed) {
                        return [2 /*return*/, next()];
                    }
                    _c.label = 5;
                case 5:
                    _i++;
                    return [3 /*break*/, 1];
                case 6:
                    if (!!controller._hasBeenInit) return [3 /*break*/, 8];
                    return [4 /*yield*/, controller.postConstructor()];
                case 7:
                    _c.sent();
                    _c.label = 8;
                case 8:
                    f = controller[route.method];
                    argsNames = retrieveArgumentsNamesFromRoute(route.path);
                    argsValues = [];
                    for (_b = 0, argsNames_1 = argsNames; _b < argsNames_1.length; _b++) {
                        arg = argsNames_1[_b];
                        argsValues.push(req.params[arg]);
                    }
                    if (route.body != null) {
                        b = req.body;
                        if (route.body.schema) {
                            b = new validate_object_1.ValidateObject(b, route.body.schema, req.acceptsLanguages());
                        }
                        argsValues.push(b);
                    }
                    argsValues.push(req);
                    argsValues.push(res);
                    controller._ctxMap = {};
                    f.apply(controller, argsValues)
                        .then(function (r) {
                        if (!r) {
                            logger_1.logger.error("Wait, you have a method in a controller without any return!!");
                            logger_1.logger.error("Method info: " + route.type + " " + route.path);
                            throw new Error("Method without any return!");
                        }
                        if (route.isAPI) {
                            var body = app.apiResponseWrapper.onSuccess(r);
                            return res.send(body);
                        }
                        else {
                            if (r instanceof skip_response_1.default) {
                                r.performResponse(req, res);
                                return next();
                            }
                            if (r.performResponse) {
                                return r.performResponse(req, res);
                            }
                            res.send(r);
                        }
                    })
                        .catch(function (error) {
                        logger_1.logger.info(error);
                        var status = 400;
                        var e = error;
                        if (e.statusCode) {
                            status = e.statusCode;
                        }
                        if (!res.headersSent) {
                            res.status(status);
                        }
                        if (route.isAPI) {
                            var body = app.apiResponseWrapper.onError(error);
                            res.send(body);
                        }
                        else {
                            next(error);
                        }
                    });
                    return [2 /*return*/];
            }
        });
    }); };
}
function generateRouter(app, controller, originalController, routes) {
    var router = express.Router();
    for (var _i = 0, _a = originalController.routes; _i < _a.length; _i++) {
        var route = _a[_i];
        var func = void 0;
        switch (route.type) {
            case http_verb_1.HttpVerb.GET:
                func = router.get;
                break;
            case http_verb_1.HttpVerb.POST:
                func = router.post;
                break;
            case http_verb_1.HttpVerb.PUT:
                func = router.put;
                break;
            case http_verb_1.HttpVerb.DELETE:
                func = router.delete;
                break;
            case http_verb_1.HttpVerb.PATCH:
                func = router.patch;
                break;
            default:
                throw new Error("The decoration type for the method " +
                    route.method +
                    " is invalid");
        }
        if (route.name) {
            routes[route.name] = (originalController.controllerPath +
                "/" +
                route.path).replace(/\/\/+/g, "/");
        }
        var callback = generateStandardCallback(controller, route, app);
        var p = route.path;
        if (!p.startsWith("/")) {
            p = "/" + p;
        }
        if (route.isMultipartForm) {
            func.call(router, p, app.upload.any(), callback);
        }
        else {
            func.call(router, p, callback);
        }
    }
    return router;
}
exports.generateRouter = generateRouter;
function useController(app, Controller, routes) {
    if (!Controller.controllerPath) {
        throw new Error('You should decorate the "' +
            Controller.name +
            '" class in order to use it');
    }
    var controller = new Controller(app);
    controller._metadata = Controller;
    var router = generateRouter(app, controller, Controller, routes);
    app.express.use(Controller.controllerPath, router);
}
exports.useController = useController;
function generateMiddlewareCallback(middleware) {
    return function (req, res, next) {
        var f = middleware.apply;
        var argsValues = [];
        argsValues.push(req);
        argsValues.push(res);
        f.apply(middleware, argsValues)
            .then(function (r) {
            if (r === base_middleware_1.BLOCK_CHAIN) {
                return;
            }
            next();
        })
            .catch(function (error) {
            logger_1.logger.info(error);
            var status = 400;
            var e = error;
            if (e.statusCode) {
                status = e.statusCode;
            }
            res.status(status).send(error);
        });
    };
}
function generateMiddlewares(app, middleware, path) {
    var callback = generateMiddlewareCallback(middleware);
    app.express.use(path, callback);
}
function useMiddleware(app, Middleware) {
    if (!Middleware.middlewarePath) {
        throw new Error('You should use at least one Middleware() decorator to a method of the "' +
            Middleware.name +
            '" class.');
    }
    var middleware = new Middleware(app);
    generateMiddlewares(app, middleware, Middleware.middlewarePath);
}
exports.useMiddleware = useMiddleware;
