"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var async_response_1 = require("./async.response");
var Jimp = require("jimp");
var fs = require("fs");
var app_1 = require("./app");
function fileExsist(path) {
    return new Promise(function (res, _) {
        fs.exists(path, function (val) {
            res(val);
        });
    });
}
function saveToCache(path, s) {
    if (!app_1.app.config.chachingImages) {
        return;
    }
    s.writeAsync(path).catch(function (err) { return console.error(err); });
}
/**
 * Generation of a File response.
 */
var FileResponse = /** @class */ (function (_super) {
    __extends(FileResponse, _super);
    function FileResponse(path) {
        var _this = _super.call(this) || this;
        _this.path = path;
        return _this;
    }
    Object.defineProperty(FileResponse.prototype, "contentType", {
        /**
         * Set the content type of the response.
         * @param value the content type
         */
        set: function (value) {
            this._contentType = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileResponse.prototype, "fileName", {
        /**
         * Set the name of the file to download
         * @param value the name of the file
         */
        set: function (value) {
            this._fileName = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileResponse.prototype, "options", {
        /**
         * Set the file options, to correctly generate the response.
         * @param value the FileOptions
         */
        set: function (value) {
            this._options = value;
        },
        enumerable: true,
        configurable: true
    });
    FileResponse.prototype.download = function (res, path) {
        if (this._fileName) {
            return res.download(path, this._fileName);
        }
        res.download(path);
    };
    /**
     * Generation of the response.
     * This method can eventually perform some transformation on output if a
     * FileOptions was specified.
     */
    FileResponse.prototype.asyncResponse = function (_, res) {
        return __awaiter(this, void 0, void 0, function () {
            var path, cachePath, img, hasProcessing, buff;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._contentType) {
                            res.contentType(this._contentType);
                        }
                        return [4 /*yield*/, app_1.app.config.ufs.getToCache(this.path, app_1.app.config.cachePath)];
                    case 1:
                        path = _a.sent();
                        if (!this._options) {
                            return [2 /*return*/, this.download(res, path)];
                        }
                        cachePath = path + "_" + JSON.stringify(this._options);
                        return [4 /*yield*/, fileExsist(cachePath)];
                    case 2:
                        if (_a.sent()) {
                            return [2 /*return*/, this.download(res, cachePath)];
                        }
                        img = {};
                        hasProcessing = false;
                        if (!!this._options.height) return [3 /*break*/, 4];
                        return [4 /*yield*/, Jimp.read(path)];
                    case 3:
                        img = _a.sent();
                        img = img.resize(this._options.width, Jimp.AUTO);
                        hasProcessing = true;
                        _a.label = 4;
                    case 4:
                        if (!(this._options.width && this._options.height)) return [3 /*break*/, 6];
                        hasProcessing = true;
                        return [4 /*yield*/, Jimp.read(path)];
                    case 5:
                        img = _a.sent();
                        img = img.resize(this._options.width, this._options.height);
                        _a.label = 6;
                    case 6:
                        if (!hasProcessing) return [3 /*break*/, 8];
                        return [4 /*yield*/, img.getBufferAsync(this._contentType)];
                    case 7:
                        buff = _a.sent();
                        res.send(buff);
                        res.end();
                        saveToCache(cachePath, img);
                        return [2 /*return*/];
                    case 8:
                        this.download(res, path);
                        return [2 /*return*/];
                }
            });
        });
    };
    return FileResponse;
}(async_response_1.default));
exports.default = FileResponse;
