"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var app_1 = require("./app");
var LocalUFS = /** @class */ (function () {
    function LocalUFS() {
    }
    LocalUFS.prototype.unlink = function (path, cb) {
        fs.unlink(path, cb);
    };
    LocalUFS.prototype.stat = function (path) {
        return new Promise(function (res, rej) {
            fs.stat(app_1.app.config.uploadPath + "/" + path, function (err, r) {
                if (err) {
                    return rej(err);
                }
                res(r);
            });
        });
    };
    LocalUFS.prototype.getToCache = function (path, _) {
        return new Promise(function (res, _) {
            return res(app_1.app.config.uploadPath + "/" + path);
        });
    };
    LocalUFS.prototype.uploadFile = function (uploadMedia) {
        return new Promise(function (res, _) {
            return res(uploadMedia);
        });
    };
    LocalUFS.prototype.uploadFileFromCache = function (path, cachePath) {
        return new Promise(function (res, rej) {
            fs.copyFile(cachePath + "/" + path, app_1.app.config.uploadPath + "/" + path, function (err) {
                if (err) {
                    return rej(err);
                }
                return res();
            });
        });
    };
    return LocalUFS;
}());
exports.LocalUFS = LocalUFS;
