"use strict";
/**
 * This module contains a set of standard verifiers to ensure user authentication
 * and authorization.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var role_entity_1 = require("./entities/role.entity");
/**
 * Verify that the user is authenticated.
 */
function authUser(req, _) {
    if (!req.user || req.user === undefined) {
        return false;
    }
    return true;
}
exports.authUser = authUser;
/**
 * Verify that the user is NOT authenticated.
 */
function notAuthUser(req, res) {
    return !authUser(req, res);
}
exports.notAuthUser = notAuthUser;
/**
 * Verify that the user is logged and that is at least a Staff member.
 */
function isStaffOrGreater(req, res) {
    if (!authUser(req, res)) {
        return false;
    }
    if (req.user.level >= role_entity_1.default.STAFF_LEVEL) {
        return true;
    }
    return false;
}
exports.isStaffOrGreater = isStaffOrGreater;
